/* ============ BOOPSI GADGETS  ============= */
/* Externe Bibliotheken einbinden */
if(~show('l','rexxsupport.library'))
then call addlib('rexxsupport.library',0,-30,0)
if(~show('l','apig.library'))
 then call addlib('apig.library',0,-30,0)
/* Messageport anlegen */
portname = "boopsi_port"
p = openport(portname)
/* Intuition-Konstanten aktivieren */
call set_apig_globals()
/* --- Fenster ffenen --- */
/* Workbench-Screen */
screen   = lockpubscreen(null())
wintitle = "APIG v3.1 - Boopsi Beispiele"
ptrtitle = allocvec(length(wintitle)+1,MEMF_CLEAR)
call export(ptrtitle,wintitle)
winidcmp = CLOSEWINDOW+GADGETUP+GADGETDOWN+MOUSEMOVE
winflags = WINDOWCLOSE+WINDOWDRAG+WINDOWSIZING,
           +WINDOWDEPTH+GIMMEZEROZERO+ACTIVATE
tags = allocatetagitems(12)
  call settagslot(tags,0,WA_PUBSCREEN,'p',screen)
  call settagslot(tags,1,WA_IDCMP,'n',winidcmp)
  call settagslot(tags,2,WA_FLAGS,'n',winflags)
  call settagslot(tags,3,WA_TOP,'n',30)
  call settagslot(tags,4,WA_HEIGHT,'n',186)
  call settagslot(tags,5,WA_TITLE,'p',ptrtitle)
  call settagslot(tags,6,TAG_DONE,'n',0)
w1  = openwindowtaglist(portname,null(),tags,0)
rp1 = getwindowrastport(w1)
/* --- Gadgets definieren --- */
/* Proportional-Gadget */
 call settagslot(tags,0,GA_LEFT,'n',20)
 call settagslot(tags,1,GA_TOP,'n',50)
 call settagslot(tags,2,GA_WIDTH,'n',360)
 call settagslot(tags,3,GA_HEIGHT,'n',10)
 call settagslot(tags,4,GA_ID,'n',10)
 call settagslot(tags,5,PGA_NEWLOOK,'n',1)
 call settagslot(tags,6,GA_RELVERIFY,'n',1)
 gadtxt=" Bereich 0-100 "
 itext1 = makeitext(w1,gadtxt,0,-14,2,1,JAM2,,,)
 call settagslot(tags,7,GA_INTUITEXT,'p',itext1)
 call settagslot(tags,8,PGA_FREEDOM,'n',FREEHORIZ)
 call settagslot(tags,9,TAG_END,'n',0)
propgad = newobjecta(null(),"propgclass",tags)
total = 100
/* String-Gadget */
 call settagslot(tags,0,GA_LEFT,'n',14)
 call settagslot(tags,1,GA_TOP,'n',20)
 call settagslot(tags,2,GA_WIDTH,'n',410)
 call settagslot(tags,3,GA_HEIGHT,'n',10)
 call settagslot(tags,4,GA_ID,'n',20)
 gadtitle = " Eingabe max. 60 Zeichen "
 itext2 = makeitext(w1,gadtitle,0,-14,2,1,JAM2,,,)
 call settagslot(tags,5,GA_INTUITEXT,'p',itext2)
 call settagslot(tags,7,STRINGA_MAXCHARS,'n',60)
 deftxt="Mit STRINGA_TEXTVAL initialisierter Text"
 initstrg=makepointer(w1,0,length(deftxt)+1,MEMF_CLEAR)
 call export(initstrg,deftxt)
 call settagslot(tags,8,STRINGA_TEXTVAL,'p',initstrg)
 call settagslot(tags,9,TAG_END,'n',0)
strgad = newobjecta(null(),"strgclass",tags)
/* Integer-String-Gadget */
 call settagslot(tags,0,GA_LEFT,'n',450)
 call settagslot(tags,2,GA_WIDTH,'n',50)
 call settagslot(tags,4,GA_ID,'n',30)
 gadtitle = " Endwert max. 99999 "
 itext3 = makeitext(w1,gadtitle,-8,-14,2,1,JAM2,,,)
 call settagslot(tags,5,GA_INTUITEXT,'p',itext3)
 call settagslot(tags,7,STRINGA_LONGVAL,'n',200)
 call settagslot(tags,8,STRINGA_MAXCHARS,'n',6)
 border = makeborder(w1,0,1,52,11,1,0,JAM1,0)
 call settagslot(tags,9,GA_Border,'p',border)
 call settagslot(tags,10,TAG_END,'n',0)
intgad = newobjecta(null(),"strgclass",tags)
/* 2 vertikale Proportional-Gadgets
   (miteinander verbunden */
 call settagslot(tags,0,GA_LEFT,'n',450)
 call settagslot(tags,1,GA_TOP,'n',40)
 call settagslot(tags,2,GA_WIDTH,'n',16)
 call settagslot(tags,3,GA_HEIGHT,'n',90)
 call settagslot(tags,4,GA_ID,'n',40)
 call settagslot(tags,5,GA_IMMEDIATE,'n',1)
 call settagslot(tags,6,GA_RELVERIFY,'n',1)
 call settagslot(tags,7,PGA_NEWLOOK,'n',1)
 call settagslot(tags,8,PGA_TOP,'n',65535)
 call settagslot(tags,9,PGA_TOTAL,'n',65535)
 call settagslot(tags,10,PGA_FREEDOM,'n',FREEVERT)
 call settagslot(tags,11,TAG_END,'n',0)
 vgad1 = newobjecta(null(),"propgclass",tags)
 call settagslot(tags,0,GA_LEFT,'n',490)
 call settagslot(tags,1,GA_TOP,'n',40)
 call settagslot(tags,2,GA_WIDTH,'n',16)
 call settagslot(tags,3,GA_HEIGHT,'n',90)
 call settagslot(tags,4,GA_ID,'n',50)
 call settagslot(tags,5,GA_IMMEDIATE,'n',1)
 call settagslot(tags,6,GA_RELVERIFY,'n',1)
 call settagslot(tags,7,PGA_TOP,'n',0)
 call settagslot(tags,8,PGA_TOTAL,'n',65535)
 call settagslot(tags,9,PGA_FREEDOM,'n',FREEVERT)
 call settagslot(tags,10,TAG_END,'n',0)
 vgad2 = newobjecta(null(),"propgclass",tags)
 endwert = 100
/* --- Gadgets mit einer Framebox versehen --- */
call rahmen()
/* --- Gadgets einbinden --- */
call addgadget(w1,propgad,-1)
call addgadget(w1,strgad,-1)
call addgadget(w1,intgad,-1)
call addgadget(w1,vgad1,-1)
call addgadget(w1,vgad2,-1)
call refreshglist(propgad,w1,null(),-1)
/* --- Auf Reaktion des Anwenders warten --- */
warten = " Die Gadgets warten auf eine Eingabe!"
call pitext(rp1,14,138,warten,1,0,JAM2,0)
exitme=0
do forever
  x = waitpkt(portname)
  do while exitme=0
   msg = getpkt(portname)
   if msg = '0000 0000'x then leave
   class = getarg(msg,0)
   iaddr = getarg(msg,8)
   gadid = getarg(msg,9)
   if class = CLOSEWINDOW then exitme = 1
   x = REPLY(msg,0)
   call auswertung()
  end
  if exitme = 1 then leave
end
/* ---  Aufrumen --- */
call disposeobject(propgad)
call disposeobject(strgad)
call disposeobject(intgad)
call disposeobject(vgad1)
call disposeobject(vgad2)
call disposeobject(frame1img)
call disposeobject(frame2img)
call disposeobject(frame3img)
call disposeobject(frame4img)
call closewindow(w1)
call unlockpubscreen(null(),screen)
call freetagitems(tags)
call freevec(ptrtitle)
call flushlibs()
exit
auswertung:
 call pitext(rp1,16,151,Copies(" ",64),1,0,JAM2,0)
 call pitext(rp1,14,138,Copies(" ",64),1,0,JAM2,0)
 spezialinfo = getvalue(iaddr,34,4,'p')
 select
   when gadid = 10 then do /* Proportional-Gadget */
    pwert = getvalue(spezialinfo,2,2,'n')
    gadpot = trunc((pwert/65535) * total)
    call pitext(rp1,390,52,"    ",1,0,JAM2,0)
    call pitext(rp1,390,52,gadpot,1,0,JAM2,0)
    txtpg = "Horizontales PropGadget wurde bettigt!"
    call pitext(rp1,16,151,txtpg,1,0,JAM2,0)
    end
   when gadid = 20 then do /* String-Gadget */
    inhalt = getvalue(spezialinfo,0,4,'s')
    call pitext(rp1,16,151,inhalt,1,0,JAM2,0)
    txtsg = "Letzte Eingabe String-Gadget:"
    call pitext(rp1,14,138,txtsg,1,0,JAM2,0)
   end
   when gadid = 30 then do /* Integer-Gadget */
    wert = getvalue(spezialinfo,28,4,'n')
    etxt= "Neuer Endwert ->" wert
    call pitext(rp1,16,151,etxt,1,0,JAM2,0)
    txtig = "Letzte Eingabe Integer-Gadget:"
    call pitext(rp1,14,138,txtig,1,0,JAM2,0)
   end
   when gadid = 40 |gadid = 50 then do
    intinfo = getvalue(intgad,34,4,'p')
    endwert = getvalue(intinfo,28,4,'n')
    info1 = getvalue(vgad1,34,4,'p')
    info2 = getvalue(vgad2,34,4,'p')
    pwert = getvalue(info1,4,2,'n')
    gadpot1 = trunc((pwert/65535) * endwert)
    gadpot2 = 65535 - pwert
    gadpos2 = endwert - gadpot1
    call setvalue(info2,4,2,'n',gadpot2)
    call refreshglist(propgad,w1,null(),-1)
    txtpg = "Vertikales PropGadget:"
    call pitext(rp1,14,138,txtpg,1,0,JAM2,0)
    if gadid = 40
      then call pitext(rp1,440,151,gadpot1 gadpos2,
                                        1,0,JAM2,0)
      else do
      vtxt2 = " Finger weg von diesem Gadget!"
      call pitext(rp1,16,151,vtxt2,1,0,JAM2,0)
      end
   end
   otherwise nop
 end
return
/* Bibliotheken freigeben */
flushlibs:
 if show('l','apig.library')
  then remlib('apig.library')
 if show('l','rexxsupport.library')
  then remlib('rexxsupport.library')
 address COMMAND 'avail >NIL: flush'
return
rahmen:
 /* Proportinal-Gadget */
 call SETTAGSLOT(tags,0,IA_WIDTH,'n',420)
 call SETTAGSLOT(tags,1,IA_HEIGHT,'n',14)
 call SETTAGSLOT(tags,2,IA_Recessed,'n',1)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 frame1img = NEWOBJECTA(null(),"frameiclass",tags)
 call DRAWIMAGE(rp1,frame1img,10,48)
 /* Schieberposition = 0 */
 call pitext(rp1,390,52,"0",1,0,JAM2,0)
 /* String-Gadget Eingabe */
 call SETTAGSLOT(tags,0,IA_WIDTH,'n',420)
 frame2img = NEWOBJECTA(null(),"frameiclass",tags)
 call DRAWIMAGE(rp1,frame2img,10,18)
 /* String-Gadgets Ausgabe */
 call SETTAGSLOT(tags,0,IA_WIDTH,'n',590)
 frame3img = NEWOBJECTA(null(),"frameiclass",tags)
 call DRAWIMAGE(rp1,frame3img,10,148)
 intxt = "Alle Eingaben mit RETURN abschlieen! "
 call pitext(rp1,10,70,intxt,2,1,JAM2,0)
 cltxt = " CLOSE-Gadget beendet das Programm!   "
 call pitext(rp1,10,80,cltxt,2,3,JAM2,0)
 /* Vertikale Proportional-Gadgets */
 call SETTAGSLOT(tags,0,IA_WIDTH,'n',72)
 call SETTAGSLOT(tags,1,IA_HEIGHT,'n',120)
 call SETTAGSLOT(tags,2,TAG_END,'n',0)
 frame4img = NEWOBJECTA(null(),"frameiclass",tags)
 call DRAWIMAGE(rp1,frame4img,442,16)
return
