/* BOOPSI IMAGES BEISPIELE */
 /* Externe Bibliotheken einbinden */
if(~show('l','rexxsupport.library'))
  then call addlib('rexxsupport.library',0,-30,0)
if(~show('l','apig.library'))
  then call addlib('apig.library',0,-30,0)
/* Messageport ffnen */
portname = "boopsistuff_port"
p = openport(portname)
/* Intuition-Konstanten setzen */
call set_apig_globals()
/* Fenster ffnen */
screen = LOCKPUBSCREEN(null()) /* Workbench screen */
drinfo = GETSCREENDRAWINFO(screen)
wintitle = "APIG v3.1 Boopsi Images Beispiele"
ptrtitle = ALLOCVEC(length(wintitle)+1,MEMF_CLEAR)
call export(ptrtitle,wintitle)
winidcmp = CLOSEWINDOW+GADGETUP+GADGETDOWN+MOUSEMOVE
winflags = WINDOWCLOSE+WINDOWDRAG+WINDOWSIZING+,
           +WINDOWDEPTH+GIMMEZEROZERO+ACTIVATE
/* Window-Tags */
tags = ALLOCATETAGITEMS(8)
 call SETTAGSLOT(tags,0,WA_PUBSCREEN,'p',screen)
 call SETTAGSLOT(tags,1,WA_IDCMP,'n',winidcmp)
 call SETTAGSLOT(tags,2,WA_FLAGS,'n',winflags)
 call SETTAGSLOT(tags,3,WA_HEIGHT,'n',255)
 call SETTAGSLOT(tags,4,WA_TITLE,'p',ptrtitle)
 call SETTAGSLOT(tags,5,TAG_END,'n',0)
w1  = OPENWINDOWTAGLIST(portname,null(),tags,0)
rp1 = GETWINDOWRASTPORT(w1)
/* Images */
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',DEPTHIMAGE)
 call SETTAGSLOT(tags,1,SYSIA_DRAWINFO,'p',drinfo)
 call SETTAGSLOT(tags,2,SYSIA_SIZE,'n',SYSISIZE_MEDRES)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 depthimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',ZOOMIMAGE)
 zoomimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',SIZEIMAGE)
 sizeimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',CLOSEIMAGE)
 closeimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',SDEPTHIMAGE)
 sdepthimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',CHECKIMAGE)
 checkimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',MXIMAGE)
 mximg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',UPIMAGE)
 upimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',DOWNIMAGE)
 downimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',LEFTIMAGE)
 leftimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',RIGHTIMAGE)
 rightimg = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',LEFTIMAGE)
 call SETTAGSLOT(tags,2,SYSIA_SIZE,'n',SYSISIZE_HIRES)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 lft2img = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,SYSIA_WHICH,'n',RIGHTIMAGE)
 rght2img = NEWOBJECTA(null(),"sysiclass",tags)
 call SETTAGSLOT(tags,0,IA_WIDTH,'n',250)
 call SETTAGSLOT(tags,1,IA_HEIGHT,'n',10)
 call SETTAGSLOT(tags,2,TAG_END,'n',0)
 frame1img = NEWOBJECTA(null(),"frameiclass",tags)
 call SETTAGSLOT(tags,2,IA_Recessed,'n',1)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 frame2img = NEWOBJECTA(null(),"frameiclass",tags)
 call SETTAGSLOT(tags,2,IA_FGPEN,'n',1)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 rect1img = NEWOBJECTA(null(),"fillrectclass",tags)
 call SETTAGSLOT(tags,2,IA_FGPEN,'n',2)
 call SETTAGSLOT(tags,3,TAG_END,'n',0)
 rect2img = NEWOBJECTA(null(),"fillrectclass",tags)
call DRAWIMAGE(rp1,depthimg,30,20)
call DRAWIMAGE(rp1,zoomimg,30,40)
call DRAWIMAGE(rp1,sizeimg,30,60)
call DRAWIMAGE(rp1,closeimg,30,80)
call DRAWIMAGE(rp1,sdepthimg,30,100)
call DRAWIMAGE(rp1,checkimg,30,120)
call DRAWIMAGE(rp1,mximg,30,140)
call DRAWIMAGE(rp1,upimg,30,160)
call DRAWIMAGE(rp1,downimg,30,180)
call DRAWIMAGE(rp1,leftimg,30,200)
call DRAWIMAGE(rp1,rightimg,30,220)
call DRAWIMAGE(rp1,lft2img,260,200)
call DRAWIMAGE(rp1,rght2img,285,200)
call DRAWIMAGESTATE(rp1,depthimg,150,20,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,zoomimg,150,40,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,sizeimg,150,60,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,closeimg,150,80,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,sdepthimg,150,100,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,checkimg,150,120,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,mximg,150,140,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,upimg,150,160,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,downimg,150,180,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,leftimg,150,200,
                              IDS_SELECTED,drinfo)
call DRAWIMAGESTATE(rp1,rightimg,150,220,
                              IDS_SELECTED,drinfo)
call DRAWIMAGE(rp1,frame1img,260,30)
call DRAWIMAGE(rp1,frame2img,260,44)
call DRAWIMAGE(rp1,rect1img,260,84)
call DRAWIMAGE(rp1,rect2img,260,98)
/* Auf das Anklicken des CLOSE-Gadgets warten */
exitme = 0
do while exitme = 0
 x = waitpkt(portname)
 do forever
  msg = getpkt(portname)
  if msg = '0000 0000'x then leave
  msgclass  = getarg(msg,0)
  x = reply(msg,0)
  if msgclass = CLOSEWINDOW then exitme = 1
 end
end
/* Aufrumen */
call DISPOSEOBJECT(depthimg)
call DISPOSEOBJECT(zoomimg)
call DISPOSEOBJECT(sizeimg)
call DISPOSEOBJECT(closeimg)
call DISPOSEOBJECT(sdepthimg)
call DISPOSEOBJECT(upimg)
call DISPOSEOBJECT(rightimg)
call DISPOSEOBJECT(downimg)
call DISPOSEOBJECT(checkimg)
call DISPOSEOBJECT(mximg)
call DISPOSEOBJECT(leftimg)
call DISPOSEOBJECT(frame1img)
call DISPOSEOBJECT(frame2img)
call DISPOSEOBJECT(rect1img)
call DISPOSEOBJECT(rect2img)
call DISPOSEOBJECT(rgth2img)
call DISPOSEOBJECT(lft2img)
call CLOSEWINDOW(w1)
call FREESCREENDRAWINFO(screen,drinfo)
call UNLOCKPUBSCREEN(null(),screen)
call FREETAGITEMS(tags)
call FREEVEC(ptrtitle)
exit
